<?php
/*
Plugin Name: WordPress DB CharCode
Plugin URI: http://www.is-p.cc/wordpress/plug-in/db-char-codedb/660
Description: データベースの文字コードを調べる
Version: 1.0
Author: is-p
Author URI: http://www.is-p.cc
*/


/* =====================================================
 WordPressに処理の追加
===================================================== */

add_action('admin_menu', 'wp_db_char_menu');

function wp_db_char_menu() {
	add_options_page('wp_db_charcode_options', 'DB 文字コード表示', 8, __FILE__, 'wp_db_char_options');
}

function wp_db_char_options() {
	global $wpdb;
	$bflag = false;

	echo '<div class="wrap"><div id="icon-options-general" class="icon32"><br /></div>';
	echo '<h2>データベース 文字コード表示</h2>';

	//
	// SESSION
	//
	$results = $wpdb->get_results("SHOW SESSION VARIABLES LIKE 'character\_set\_%';");

	echo '<h3>[ WordPress DataBase 文字コード (SESSION) ]</h3>';
	echo '<table summary="サーバー側　文字コード"  class="widefat post" cellspacing="0" style="width: 250px;">';
	echo '<thead><tr><th>設定項目</th><th>値</th></tr></thead>';
	echo '<tbody>';

	foreach($results as $data) {
		if($bflag) {
			echo '<tr class="alternate"><td>' . $data->Variable_name . '</td><td>' . $data->Value . '</td></tr>';
			$bflag = false;
		} else {
			echo '<tr><td>' . $data->Variable_name . '</td><td>' . $data->Value . '</td></tr>';
			$bflag = true;
		}
	}

	echo '</tbody></table>';


	//
	// GLOBAL
	//
	$bflag = false;
	$results = $wpdb->get_results("SHOW GLOBAL VARIABLES LIKE 'character\_set\_%';");

	echo '<h3>[ Server側 文字コード (GLOBAL) ]</h3>';
	echo '<table summary="サーバー側　文字コード"  class="widefat post" cellspacing="0" style="width: 250px;">';
	echo '<thead><tr><th>設定項目</th><th>値</th></tr></thead>';
	echo '<tbody>';

	foreach($results as $data) {
		if($bflag) {
			echo '<tr class="alternate"><td>' . $data->Variable_name . '</td><td>' . $data->Value . '</td></tr>';
			$bflag = false;
		} else {
			echo '<tr><td>' . $data->Variable_name . '</td><td>' . $data->Value . '</td></tr>';
			$bflag = true;
		}
	}

	echo '</tbody></table>';

}

?>
